#ifndef __GENERIC_H
#define __GENERIC_H

/* set to 1 for shoutcast server compatibility */
#define SHOUTCAST_COMPATIBILITY 0

/* soundcard tweaks */
#define SAMPLE_RATE 44100 // 44100
#define BUF_SIZE 4608 // 1152 (mp3 default framesize) *2 (16bit) *2 (stereo)
#define FRAGSIZE 0x000c // 4096 bytes
#define FRAGCOUNT 0x7fff // no limit

/* mp3 channels - the standard interface can't be changed from here */
#define MAX_CHANNELS 6

/* playlist */
#define MAX_PLAYLIST_ENTRY 200
#define MAX_PATH_SIZE 200

/* encoding quality - best is suggested unless
   the encoder runs out of cpu */
#define QUALITY 1 /* best=1 worse=9 */

/* port on wich MuSE listens when in daemon mode */
#define LISTENPORT 6969

/* VUMeter tweaks
   be careful: if (SPACING>(PEAK_VOLUME/NUM_CELLS)) bad_things_happen(tm); */
#define PEAK_VOLUME 127
#define NUM_CELLS 10
#define SPACING 2
#define TALK_VOLUME 0.3

/* clipping values *do not change unless you know what you do*
   i assume a thresold of 0.9 */
#define MAX_SAMPLE 32766
#define CLIP 29489
#define CLIP_A 10738729 // ((MAX_SAMPLE-CLIP)*(MAX_SAMPLE-CLIP))
#define CLIP_B 26212 // (MAX_SAMPLE-2*CLIP)

#endif
