#include "gui_extras.h"
#include <FL/fl_draw.H>
#include <iostream.h>


/*
  inline void infoz() {
  infowindow = new Fl_Window(235, 200, "Info about MuSE");
  Fl_Button *but = new Fl_Button(30, 30, 100, 45, "hallo");
  infowindow->end();
  infowindow->show();
  }

  void info_win() { 
  Fl_Window *infowindow = NULL;
  
  if(infowindow!=NULL) {
    if(!infowindow->shown())
    infoz();
    } else
    infoz();
    }
*/


LevelBlock::LevelBlock(int X, int Y, int W, int H) : Fl_Widget(X,Y,W,H)
{ 
  Color[0] = 15;
  Color[1] = 15;
  color_index = 0;
}

void LevelBlock::draw()
{
  fl_rectf(x(), y(), w(), h());
}

Level::Level(int X, int Y, int W, int H) : Fl_Group(X,Y,W,H) 
{

  unsigned int totalspacing = (H - (SPACING * NUM_CELLS))/NUM_CELLS; 
  unsigned int blockheight = totalspacing - SPACING;

  int n = 0;
  int i = 0;
  unsigned int x = PEAK_VOLUME;
  block[0] = new LevelBlock(X,Y,W,blockheight);
  block[0]->Color[1] = FL_RED;
  for (i = 1; i < NUM_CELLS; i++)
    { 
      x = x - (PEAK_VOLUME/NUM_CELLS);
      n  = n + totalspacing;
      block[i] = new LevelBlock(X, Y+n, W, blockheight);
      if (x > (PEAK_VOLUME/NUM_CELLS)*(NUM_CELLS-2))
	{
	  block[i]->Color[1] = FL_YELLOW;
	}
      else
	{
	  block[i]->Color[1] = FL_GREEN;
	}
    }
  
  n = NUM_CELLS;
  for (i = 0; i < NUM_CELLS; i++)
    {
      value[i] = (PEAK_VOLUME/NUM_CELLS)*n;
      /* cout << "value[" << i << "]:  " << value [i] << endl; */
      n--;
    }
  end();  // from the FLTK documentation....says this is needed for extending Fl_Group
}

void Level::draw() 
{
  for (int i = 0; i < NUM_CELLS; i++)
    {
      fl_color(block[i]->Color[block[i]->color_index]);
      block[i]->draw();
    }
}

void Level::draw_levels(unsigned short int x) 
{
  
  int j,i;
  for (i = 0; i < NUM_CELLS; i ++)
    {
      if (x > value[i]) 
	 {
  	  for (j = i; j < NUM_CELLS; j++) //count up from i, paint its color
  	      block[j]->color_index = 1;

    	  i--;  //step one down in the array

    	  for(j = i; j >= 0; j--)  // count down from i, paint grey
    	      block[j]->color_index = 0;
  	  break;
  	}
    }
  redraw();

}
